//https://www.baldengineer.com/when-do-you-use-the-arduinos-to-use-serial-flush.html
#include "SevenSegmentTM1637.h"
#include "OneButton.h"
#include <ArduinoJson.h>
#include <SoftwareSerial.h>
SoftwareSerial Sim800l(4,5); //RX,TX

char* json;
char* parseState = "INIT";
//char* parseState = "JSON";
char* buttonState = "";
String readings;
String readings2;
String debug;

bool AT_loop = true;
bool read_state = false;


//Millis/////////////////////
unsigned long startMillis;
unsigned long Ticker_startMillis;
unsigned long currentMillis;
unsigned long Backlight_startMillis;
unsigned long Backlight_currentMillis;
unsigned long LED_startMillis;
unsigned long LED_currentMillis;
const unsigned long LED_period = 10;
const unsigned long period = 1000;
const unsigned auto_update_timer = 1000*60*10;
int i_countdown = 35; //Init Countdown
int countdown = 60; //Disconnect


//JSON//////////////////////
//const size_t capacity = 6*JSON_OBJECT_SIZE(4) + 280;
const size_t capacity = 6*JSON_OBJECT_SIZE(4) + JSON_OBJECT_SIZE(6) + 420;
DynamicJsonDocument doc(capacity);


//DISPLAY//////////////////////////////
const byte PIN_CLK = 16;
const byte PIN_DIO = 14;  
SevenSegmentTM1637    display(PIN_CLK, PIN_DIO);
String ticker = "----";
String ticker_d = "";
String ticker_v = "";
String print_ticker;
int ticker_lenght = 4;
int ticker_d_lenght;
int ticker_v_lenght;
int i = 0;
int region = 1;
const unsigned long textspeed = 250;


//Onebutton
OneButton button(12, true);

//Backlightsensor
const int analogInPin = A0;  
int sensorValue = 0;
int BacklightValue = 100;

//LED
int brightness = 255; 
int led = 13;
int led_state = 3;
int fadeAmount;


void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  Sim800l.begin(9600);
  display.begin();
  startMillis = millis();
  Backlight_startMillis = millis();
  LED_startMillis = millis();
  Ticker_startMillis = millis();

  button.attachDoubleClick(doubleclick);            // link the function to be called on a doubleclick event.
  button.attachClick(singleclick);                  // link the function to be called on a singleclick event.
  button.attachLongPressStop(longclick);            // link the function to be called on a longpress event.

Serial.println("INIT");

 }



  
void loop() {

currentMillis = millis();

button.tick();

Sim800();

Backlightsensor();

LED_State();



//SINGLECLICK
if (buttonState == "SINGLECLICK") // Change region
{
region = region+1;
if (region > 2) {region = 1;}
Serial.println("Region: ");
Serial.println(region);
if (region == 1) {ticker = ticker_d;}
if (region == 2) {ticker = ticker_v;}
buttonState = "";
i = 0;
}

//LONGCLICK
if (buttonState == "LONGCLICK")
{
parseState = "REFRESH";
ticker = "---- UPDATING PRICES ----";
buttonState = "";
i = 0;
}

//AUTOUPDATE
if (parseState == "AUTO_UPDATE") // Change region
{
parseState = "SAPBR";
ticker = "---- UPDATING PRICES ----";
i = 0;
}


//TICKER//////////////////////////////////////////////////////////
if (currentMillis - Ticker_startMillis >= textspeed)
        { 

          print_ticker = ticker.substring(i, i+4);
          /*Serial.print("print_ticker: ");
          Serial.println(print_ticker);
          Serial.print("i: ");
          Serial.println(i);*/
          display.print(print_ticker);
          ticker_lenght = ticker.length()-4;
          i++;    
            if (i >= ticker_lenght)
              { i = 0; }          
          Ticker_startMillis = currentMillis;
        }
}



void Sim800() {


//Clear Serial
if (read_state == false) {
while(Sim800l.available())
  Sim800l.read(); 
}
/*

//Clear Serial
if (read_state == false) {
while(Sim800l.available()) {
  Serial.write(Sim800l.read());
 }
}
*/
//Read Serial
if (read_state == true) {
 while (Sim800l.available()) {
   //delay(2);  //delay to allow byte to arrive in input buffer
   char c = Sim800l.read();
   //Serial.print("c: ");
   //Serial.println(c);
       if (c != '\n') {readings += c;}
  }
}
// while (Sim800l.available()) {Serial.write(Sim800l.read());}



if (currentMillis - startMillis >= period)
{


         //INIT/////////////////////////////////////////////////////runs only once
         if (parseState == "INIT" && AT_loop == true) {
          i_countdown--;
          Sim800l.println("AT");
          if (i_countdown <= 0)
          {
          Serial.println("CONNECT");
          parseState = "APN";
          AT_loop = false;
          ticker = "---- CONNECT ----";
          i = 0;
                     }
          else
          {
          ticker = "---- INIT ---- CONNECT IN " + String(i_countdown) + " SEC ----";
          
          //ticker_lenght = ticker.length()-4;
          }
          startMillis += 1000;  
          }

          //DISCONNECT/////////////////////////////////////////////////////
          if (parseState == "DISCONNECT" && AT_loop == true) {
              countdown--;
          //Serial.println("DISCONNECT");
          if (countdown <= 0)
          {
          Serial.println("RECONNECT");
          countdown = 60;
          ticker = "---- RECONNECT ----";
          i = 0;
          parseState = "RECONNECT";
          AT_loop = false;
          
                     }
          else
          {//Serial.println(countdown);
          ticker = "---- DISCONNECTED ---- RETRY IN " + String(countdown) + " SEC ----";
          
          //ticker_lenght = ticker.length()-4;
         }
         startMillis += 1000;  
         }

         
         //REFRESH/////////////////////////////////////////////////////
         if (parseState == "REFRESH" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT");
         parseState = "APN";
         AT_loop = false;
         startMillis = currentMillis;
         }
         
         
         //RECONNECT/////////////////////////////////////////////////////
         if (parseState == "RECONNECT" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT");
         parseState = "APN";
         ticker = "---- RECONNECT ----";
         i = 0;
         AT_loop = false;
         startMillis = currentMillis;
         }

         //APN/////////////////////////////////////////////////////
         if (parseState == "APN" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT+SAPBR=3,1,\"APN\",\"pinternet.interkom.de\"");
         parseState = "SAPBR";
         AT_loop = false;
         startMillis = currentMillis;
         }
         
         //SAPBR/////////////////////////////////////////////////////
         if (parseState == "SAPBR" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT+SAPBR=1,1");
         parseState = "HTTPINIT";
         AT_loop = false;
         startMillis = currentMillis;
         }

         
         //HTTPINIT/////////////////////////////////////////////////////
         if (parseState == "HTTPINIT" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT+HTTPINIT");
         parseState = "URL";//CID
         AT_loop = false;
         startMillis = currentMillis;
         }

         //CID/////////////////////////////////////////////////////
         if (parseState == "CID" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT+HTTPPARA=\"CID\",1");
         parseState = "URL";
         AT_loop = false;
         startMillis = currentMillis;
         }

         //URL/////////////////////////////////////////////////////
         if (parseState == "URL" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT+HTTPPARA=\"URL\",\"https://creativecommons.tankerkoenig.de/json/prices.php?ids=91fb170e-e7ce-4ef3-bdf1-835fba2d3ae6,da422627-848f-429a-adbd-30e8c9b0b3a7,3c44ee73-05de-4edd-887b-774fff56a8cb,51d4b665-a095-1aa0-e100-80009459e03a,51d4b63c-a095-1aa0-e100-80009459e03a,005056ba-7cb6-1ed2-bceb-c3b0813b8d50&apikey=708a848a-cbc1-71f0-5dbe-d3d6a3d18792\"");
         parseState = "SSL";
         AT_loop = false;
         startMillis = currentMillis;
         }

         //SSL/////////////////////////////////////////////////////
         if (parseState == "SSL" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT+HTTPSSL=1");
         parseState = "HTTPACTION";
         AT_loop = false;

         startMillis = currentMillis;
         }


         
         //PARSE/////////////////////////////////////////////////////
         if (parseState == "PARSE" && AT_loop == true) {
         
         
         Serial.print("Status: ");
         Serial.println(parseState);
         Serial.print("Antwort: ");
         Serial.println(readings);
         Serial.print("Antwortlänge: ");
         Serial.println(readings.length());
         
         //PARSER TEST 


             //SPLIT
             if (readings.length() < 100)
             {  
              Serial.println("DISCONNECT SPLIT");
                parseState = "DISCONNECT";
                AT_loop = false;
                read_state = false;
             }
             else
             {
             readings2 = readings.substring(130, readings.length()-4);
             Serial.print("readings2: ");
             Serial.println(readings2);
             Serial.print("readings2-Länge: ");
             Serial.println(readings2.length());
             parseState = "JSON";
             AT_loop = false;
             read_state = false;
             Sim800l.println("AT+HTTPTERM");
             }
         startMillis = currentMillis;
         }

         //JSON/////////////////////////////////////////////////////
         if (parseState == "JSON" && AT_loop == true)
         {
         //readings2 = "{\"91fb170e-e7ce-4ef3-bdf1-835fba2d3ae6\":{\"status\":\"open\",\"e5\":1.168,\"e10\":1.158,\"diesel\":1.068},\"3c44ee73-05de-4edd-887b-774fff56a8cb\":{\"status\":\"open\",\"e5\":1.149,\"e10\":1.119,\"diesel\":1.039},\"51d4b63c-a095-1aa0-e100-80009459e03a\":{\"status\":\"open\",\"e5\":1.199,\"e10\":1.169,\"diesel\":1.049},\"da422627-848f-429a-adbd-30e8c9b0b3a7\":{\"status\":\"open\",\"e5\":1.159,\"e10\":1.129,\"diesel\":1.049},\"005056ba-7cb6-1ed2-bceb-c3b0813b8d50\":{\"status\":\"open\",\"e5\":1.199,\"e10\":1.169,\"diesel\":1.049},\"51d4b665-a095-1aa0-e100-80009459e03a\":{\"status\":\"open\",\"e5\":1.179,\"e10\":1.149,\"diesel\":1.049}}}";
             
         deserializeJson(doc, readings2);
         
         JsonObject T_Weissig = doc["da422627-848f-429a-adbd-30e8c9b0b3a7"];
         const char* T_Weissig_status = T_Weissig["status"]; // "open"
         float T_Weissig_diesel = T_Weissig["diesel"]; // 1.048
         T_Weissig_diesel = (T_Weissig_diesel-0.01);
         String T_Weissig_str;
            if (T_Weissig_diesel < 0) {T_Weissig_str = "CLOSED";}
            else {T_Weissig_str = String(T_Weissig_diesel);}
         
         JsonObject T_Greenline = doc["91fb170e-e7ce-4ef3-bdf1-835fba2d3ae6"];
         const char* T_Greenline_status = T_Greenline["status"]; // "open"
         float T_Greenline_diesel = T_Greenline["diesel"]; // 1.048
         T_Greenline_diesel = (T_Greenline_diesel-0.01);
            String T_Greenline_str;
            if (T_Greenline_diesel < 0) {T_Greenline_str = "CLOSED";}
            else {T_Greenline_str = String(T_Greenline_diesel);}
         Serial.print("T_Greenline_diesel: ");
         Serial.println(T_Greenline_diesel);
         
         JsonObject T_Elan = doc["3c44ee73-05de-4edd-887b-774fff56a8cb"];
         const char* T_Elan_status = T_Elan["status"]; // "open"
         float T_Elan_diesel = T_Elan["diesel"]; // 1.048
         T_Elan_diesel = (T_Elan_diesel-0.01);
         String T_Elan_str;
            if (T_Elan_diesel < 0) {T_Elan_str = "CLOSED";}
            else {T_Elan_str = String(T_Elan_diesel);}
         
         JsonObject T_Jet = doc["51d4b665-a095-1aa0-e100-80009459e03a"];
         const char* T_Jet_status = T_Jet["status"]; // "open"
         float T_Jet_diesel = T_Jet["diesel"]; // 1.048
         T_Jet_diesel = (T_Jet_diesel-0.01);
         String T_Jet_str;
            if (T_Jet_diesel < 0) {T_Jet_str = "CLOSED";}
            else {T_Jet_str = String(T_Jet_diesel);}
            
         JsonObject T_Plauenpark = doc["51d4b63c-a095-1aa0-e100-80009459e03a"];
         const char* T_Plauenpark_status = T_Plauenpark["status"]; // "open"
         float T_Plauenpark_diesel = T_Plauenpark["diesel"]; // 1.048
         T_Plauenpark_diesel = (T_Plauenpark_diesel-0.01);
         String T_Plauenpark_str;
            if (T_Plauenpark_diesel < 0) {T_Plauenpark_str = "CLOSED";}
            else {T_Plauenpark_str = String(T_Plauenpark_diesel);}
            
         JsonObject T_Star = doc["005056ba-7cb6-1ed2-bceb-c3b0813b8d50"];
         const char* T_Star_status = T_Star["status"]; // "open"
         float T_Star_diesel = T_Star["diesel"]; // 1.048
         T_Star_diesel = (T_Star_diesel-0.01);
         String T_Star_str;
            if (T_Star_diesel < 0) {T_Star_str = "CLOSED";}
            else {T_Star_str = String(T_Star_diesel);}    
         
         ticker_d = "---- GREENLINE " + String(T_Greenline_str) + " ---- ELAN " + String(T_Elan_str) + " ---- WEISSIG " + (T_Weissig_str) + " ---- JET " + String(T_Jet_str) + " ----";
         ticker_d.replace(".", "");
         //ticker_lenght = ticker.length()-4;

         ticker_v = "---- PLAUENPARK " + String(T_Plauenpark_str) + " ---- STAR " + String(T_Star_str) + " ----";
         ticker_v.replace(".", "");
         //ticker_v_lenght = ticker_v.length()-4;

         if (region == 1) {ticker = ticker_d;}
         if (region == 2) {ticker = ticker_v;}
         i = 0;
         Serial.print("Ticker: ");

         Serial.println(ticker);

         led_state = 3;
         brightness = 255;
         
         parseState = "IDLE";
         AT_loop = false;
         read_state = false;

         startMillis = currentMillis;
         }
         
}

if (currentMillis - startMillis >= period*10) 
        {


         //HTTPACTION/////////////////////////////////////////////////////
         if (parseState == "HTTPACTION" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT+HTTPACTION=0");
         parseState = "HTTPREAD";
         AT_loop = false;
         
         startMillis = currentMillis;
         }

         if (parseState == "HTTPREAD" && AT_loop == true) {
         Serial.print("Status: ");
         Serial.println(parseState);
         Sim800l.println("AT+HTTPREAD");
         parseState = "PARSE";
         AT_loop = false;
         readings = "";
         read_state = true;



         startMillis = currentMillis;
         }
        }

        //AUTO UPDATE/////////////////////////////////////////////////////
        if (currentMillis - startMillis >= auto_update_timer && parseState == "IDLE") 
                { 
                 parseState = "AUTO_UPDATE";
                 Serial.print("AUTO UPDATE");
                 }



AT_loop = "true";

}

void doubleclick() 
  {
  //display.print("DOUBLECLICK");
  //led_state = 3;
  Serial.println("doubleclick");
//  buttonState = "DOUBLECLICK";
  led_state = 4;
  brightness = 255;

  
  //brightness = 255;
  }
 
void singleclick()
  {          
  //display.print("SINGLECLICK");
  Serial.println("singleclick");
  buttonState = "SINGLECLICK";
  led_state = 1;
  brightness = 255;
  }

void longclick()
  { 
  led_state = 2;
  brightness = 255;   
  //display.print("LONGCLICK");
  buttonState = "LONGCLICK";
  Serial.println("longclick");
  //buttonState = "LONGCLICK";
                              
  }


//BACKLIGHT/////////////////////////////////////////////////////

void Backlightsensor() {
Backlight_currentMillis = millis();

if (Backlight_currentMillis - Backlight_startMillis >= period)
{
sensorValue = analogRead(analogInPin);
    //Serial.print("sensor = ");
    //Serial.println(sensorValue);

    //BacklightValue = 10-(-0.002115919/-0.005450294)*(1-exp(0.005450294*sensorValue));
    BacklightValue = sensorValue/10;
      if (BacklightValue < 10) {BacklightValue = 10;}
    //Serial.print("BacklightValue = ");
    //Serial.println(BacklightValue);
Backlight_startMillis = Backlight_currentMillis;

display.setBacklight(BacklightValue);
}
}


//LED/////////////////////////////////////////////////////
void LED_State() {
LED_currentMillis = millis();
if (LED_currentMillis - LED_startMillis >= LED_period)
{    
          
       
if (led_state == 1) {
      fadeAmount = 10;
      brightness = brightness - fadeAmount;
      if (brightness <= 20) {led_state = 0;}
                       
        }
      if (led_state == 2) {
      fadeAmount = 5;
      brightness = brightness - fadeAmount;
      if (brightness <= 20) {led_state = 0;}
                       
        }
      if (led_state == 3) {
      fadeAmount = 10;
      brightness = brightness - fadeAmount;
      if (brightness <= 0) {led_state = 4;brightness = 255;}
                       
        }
      if (led_state == 4) {
      fadeAmount = 10;
      brightness = brightness - fadeAmount;
      if (brightness <= 0) {led_state = 5;brightness = 255;}
                       
        }
      if (led_state == 5) {
      fadeAmount = 10;
      brightness = brightness - fadeAmount;
      if (brightness <= 20) {led_state = 0;}            
        }
      
LED_startMillis = LED_currentMillis;    
        
analogWrite(led, brightness);
}
}
